import { HttpClient } from '@angular/common/http';
import { Component, OnInit } from '@angular/core';
import { Observable } from 'rxjs/Observable';
import { Login } from './login';

@Component({
  selector: 'app-login',
  templateUrl: './login.component.html',
  styleUrls: ['./login.component.scss']
})
export class LoginComponent implements OnInit {
  model = new Login('', '');
  submitted = false;
  is_admin: boolean;
  logged_in_email: string;
  constructor(
    private http: HttpClient
  ) {}
  onSubmit() {
    this.postLogin(this.model).subscribe(
      res => {
        this.logged_in_email = res['email'];
        this.is_admin = res['is_admin'];
      }
    );
    this.submitted = true;
  }

  postLogin(login: Login): Observable<any> {
    return this.http.post<Login>('/login', login);
  }

  ngOnInit() {}
}
